package decoration;

public class Shape implements Comparable<Shape> {

	private int height;
	private int width;
	private int[][] shape;
	private int likes;
	private int id;
	private boolean used;

	public Shape(int width, int height, int likes, int id) {

		this.width = width;
		this.height = height;
		shape = new int[height][width];
		this.likes = likes;
		this.id = id;
		used = false;
	}

	public int getHeight() {
		return height;
	}

	public int getWidth() {
		return width;
	}

	public int[][] getShape() {
		return shape;
	}

	public int getLikes() {
		return likes;
	}

	public int getId() {
		return id;
	}

	public boolean isUsed() {
		return used;
	}

	public void setUsed(boolean used) {
		this.used = used;
	}

	public int compareTo(Shape other) {

		int result = -2;

		if (likes < other.getLikes()) {

			result = 2;
		} else if (likes == other.getLikes()) {

			if ((height * width) <= (other.getHeight() * other.getWidth())) {

				result = 1;
			} else {

				result = -1;
			}
		}

		return result;
	}
}