package decoration;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Shell {

	public static void main(String[] args) {

		Decoration decoration = new Decoration();
		Scanner scanner = null;

		try {

			scanner = new Scanner(new File("decoration.in"));
			int windows = scanner.nextInt();
			int shapes = scanner.nextInt();

			for (int i = 0; i < windows; i++) {

				int height = scanner.nextInt();
				int width = scanner.nextInt();
				decoration.getWindows().add(new Window(height, width, i + 1));
			}

			for (int i = 0; i < shapes; i++) {

				int height = scanner.nextInt();
				int width = scanner.nextInt();
				int likes = scanner.nextInt();
				Shape current = new Shape(height, width, likes, i);
				decoration.getShapes().add(current);

				for (int j = 0; j < current.getShape().length; j++) {
					for (int k = 0; k < current.getShape()[0].length; k++) {

						current.getShape()[j][k] = scanner.nextInt();
					}
				}
			}

		} catch (Exception e) {

			return;
		} finally {
			try {

				scanner.close();
			} catch (Exception e) {

				return;
			}
		}

		List<Integer> output = new ArrayList<Integer>();
		List<Integer> notSorted = new ArrayList<Integer>();
		decoration.sortWindowsAndShapes();

		for (Shape currentShape : decoration.getShapes()) {
			for (int i = 0; i < decoration.getWindows().size(); i++) {
				if (!(currentShape.isUsed())) {

					List<Integer> currentCoord = decoration.getWindows().get(i).possibileNewShape(currentShape);

					if (currentCoord.get(0) != -1) {

						currentShape.setUsed(true);
						notSorted.add(currentShape.getId());
						notSorted.add(decoration.getWindows().get(i).getId());
						notSorted.add(currentCoord.get(1));
						notSorted.add(currentCoord.get(0));
					}
				}
			}

			if (!(currentShape.isUsed())) {

				notSorted.add(currentShape.getId());
				notSorted.add(-1);
				notSorted.add(-1);
				notSorted.add(-1);
			}
		}

		for (int i = 0; i < decoration.getShapes().size(); i++) {
			for (int j = 0; j < notSorted.size(); j += 4) {
				if (notSorted.get(j) == i) {

					output.add(notSorted.get(j + 1));
					output.add(notSorted.get(j + 2));
					output.add(notSorted.get(j + 3));
					break;
				}
			}
		}

		BufferedWriter writeInFile = null;

		try {

			writeInFile = new BufferedWriter(new FileWriter("decoration.out"));
			int counter = 0;

			while (counter < output.size()) {

				writeInFile.write((output.get(counter)) + " ");
				writeInFile.write((output.get(counter + 1)) + " ");

				if (counter == output.size() - 3) {

					writeInFile.write((output.get(counter + 2)).toString());
				} else {

					writeInFile.write((output.get(counter + 2)) + "\n");
				}

				counter += 3;
			}
		} catch (IOException e) {

			return;
		} finally {
			try {
				if (writeInFile != null) {

					writeInFile.close();
				}
			} catch (IOException e) {

				return;
			}
		}
	}
}