package decoration;

import java.util.ArrayList;
import java.util.List;

public class Window implements Comparable<Window> {

	private int height;
	private int width;
	private int[][] window;
	private int shapes;
	private int likes;
	private int id;

	public Window(int width, int height, int id) {

		this.width = width;
		this.height = height;
		window = new int[height][width];
		this.id = id;
		shapes = 0;
		likes = 0;
	}

	public int getHeight() {
		return height;
	}

	public int getWidth() {
		return width;
	}

	public int getId() {
		return id;
	}

	public List<Integer> possibileNewShape(Shape shape) {

		List<Integer> result = new ArrayList<Integer>();
		result.add(-1);
		result.add(-1);

		if (shape.getShape().length <= window.length && shape.getShape()[0].length <= window[0].length) {

			int counter = 0;
			int limit = shape.getShape().length * shape.getShape()[0].length;
			int row = 0;
			int col = 0;
			boolean out = false;

			for (int i = 0; i < window.length; i++) {
				for (int j = 0; j < window[0].length; j++) {
					for (int k = 0; k < shape.getShape().length; k++) {
						for (int l = 0; l < shape.getShape()[0].length; l++) {
							if (i + k < window.length && j + l < window[0].length) {
								if (window[i + k][j + l] == 0) {
									if (counter == 0) {

										row = i + k;
										col = j + l;
									}

									counter++;
								}
							}
						}
					}

					if (counter == limit) {
						for (int k = 0; k < shape.getShape().length; k++) {
							for (int l = 0; l < shape.getShape()[0].length; l++) {

								window[k + row][l + col] = shape.getShape()[k][l];
							}
						}

						shapes++;
						likes += shape.getLikes();
						result.clear();
						result.add(row + 1);
						result.add(col + 1);
						out = true;
					} else {

						counter = 0;
					}

					if (out) {

						break;
					}
				}

				if (out) {

					break;
				}
			}
		}

		return result;
	}

	public int beauty() {

		int result = shapes * likes;

		return result;
	}

	public int compareTo(Window other) {

		int result = -1;

		if ((height * width) <= (other.getHeight() * other.getWidth())) {

			result = 1;
		}

		return result;
	}
}